jQuery(document).ready(function($) {
    var dhlparcel_shipping_checkout_servicepoint_modal_loaded;
    var dhlparcel_shipping_checkout_servicepoint_modal_busy_loading;

    $(document.body).on('change', 'form#js-delivery input[type=radio]', function () {

        $(document.body).trigger('dhlparcel_shipping:load_servicepoint_info');

    }).on('dhlparcel_shipping:load_servicepoint_info', function() {
        var element = $('form#js-delivery .delivery-options input[type=radio]:checked:first');
        var value = element.val();

        if (typeof value === "undefined") {
            return;
        }

        var id_carrier = value.replace(/[^0-9]/gi, '');

        if ($.inArray(id_carrier, dhlparcel_shipping_checkout_servicepoints) > -1) {
            $.post(dhlparcel_shipping_checkout_servicepoint_link, [], function (response) {
                try {
                    var servicepoint = response.data.view.servicepoint;
                } catch (error) {
                    alert('Error');
                    return;
                }
                element.closest('.delivery-option').nextAll('.carrier-extra-content:first').html(servicepoint);
            });
        }

    }).on('click', 'button.dhlparcel_shipping_checkout_servicepoint_button', function (e) {
        e.preventDefault();

        // Do nothing if the base modal hasn't been loaded yet.
        if (dhlparcel_shipping_checkout_servicepoint_modal_loaded === false) {
            return;
        }

        var first_address = null;
        for (var address_id in prestashop.customer.addresses) {
            first_address = prestashop.customer.addresses[address_id];
            break;
        }

        if (typeof window.dhlparcel_shipping_servicepoint_locator !== 'undefined') {
            window.dhlparcel_shipping_servicepoint_locator.setCountry(first_address.country_iso)
            if (first_address.postcode.toUpperCase() != '') {
                window.dhlparcel_shipping_servicepoint_locator.setQuery(first_address.postcode.toUpperCase())
            }
        }

        $('div.dhlparcel_shipping_modal').show();

    }).on('dhlparcel_shipping:load_servicepoint_modal', function() {
        if (dhlparcel_shipping_checkout_servicepoint_modal_loaded === true) {
            return;
        }

        if (dhlparcel_shipping_checkout_servicepoint_modal_busy_loading === true) {
            return;
        }

        dhlparcel_shipping_checkout_servicepoint_modal_busy_loading = true;

        $(document.body).append(dhlparcel_shipping_checkout_servicepoint_locator);

        // Create selection function
        window.dhlparcel_shipping_select_servicepoint = function(event)
        {
            var first_address = null;
            for (var address_id in prestashop.customer.addresses) {
                first_address = prestashop.customer.addresses[address_id];
                break;
            }

            var dhlparcel_shipping_selected_servicepoint_id = event.id;
            var postcode = first_address.postcode.toUpperCase();

            $(document.body).trigger("dhlparcel_shipping:servicepoint_selection_sync", [dhlparcel_shipping_selected_servicepoint_id, postcode, event.address.countryCode]);
            $(document.body).trigger('dhlparcel_shipping:hide_servicepoint_modal');
        };

        // Load CSS
        $('<link>')
            .appendTo('head')
            .attr({
                type: 'text/css',
                rel: 'stylesheet',
                href: dhlparcel_shipping_checkout_servicepoint_stylesheet
            });

        // Disable getScript from adding a custom timestamp
        $.ajaxSetup({cache: true});
        $.getScript("https://static.dhlparcel.nl/components/servicepoint-locator-component@latest/servicepoint-locator-component.js").done(function() {
            var options = {
                language: '',
                country: '',
                header: true,
                resizable: true,
                onSelect: window.dhlparcel_shipping_select_servicepoint
            };

            if (typeof dhlparcel_shipping_checkout_servicepoint_maps_key !== 'undefined' && dhlparcel_shipping_checkout_servicepoint_maps_key.length > 0) {
                options.googleMapsApiKey = dhlparcel_shipping_checkout_servicepoint_maps_key;
            }

            window.dhlparcel_shipping_servicepoint_locator = new dhl.servicepoint.Locator(document.getElementById("dhl-servicepoint-locator-component"), options);

            dhlparcel_shipping_checkout_servicepoint_modal_loaded = true;
            dhlparcel_shipping_checkout_servicepoint_modal_busy_loading = false;
        });

    }).on('dhlparcel_shipping:servicepoint_selection_sync', function(e, servicepoint_id, postcode, country_code) {
        // Due to the cart page not having an actual form, we will temporarily remember the selection as a shadow selection.
        // The actual checkout form will always have priority, this is just backup logic.
        var data = {
            'servicepoint_id': servicepoint_id,
            'postcode': postcode,
            'country_code': country_code
        };

        $.post(dhlparcel_shipping_checkout_servicepoint_sync, data, function (response) {
            /* Reload */
            $(document.body).trigger('dhlparcel_shipping:load_servicepoint_info');
        });

    }).on('click', 'span.dhlparcel_shipping_modal_close, div.dhlparcel_shipping_modal', function(e) {
        if (!$(e.target).is('span.dhlparcel_shipping_modal_close') && !$(e.target).is('div.dhlparcel_shipping_modal')) {
            return;
        }
        e.preventDefault();
        $(document.body).trigger('dhlparcel_shipping:hide_servicepoint_modal');

    }).on('dhlparcel_shipping:hide_servicepoint_modal', function(e) {
        $('div.dhlparcel_shipping_modal').hide();

    });

    // Preload modal, since it's loaded dynamically (hidden DOM defaults)
    $(document.body).trigger('dhlparcel_shipping:load_servicepoint_modal');
    // Check ServicePoint on first load
    $(document.body).trigger('dhlparcel_shipping:load_servicepoint_info');

});
